/*
 Copyright (c) 2002 Amduus Information Works, Inc.  
 scott_auge@yahoo.com sauge@amduus.com

 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the "Software"),
 to deal in the Software without restriction, including without limitation the
 rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 sell copies of the Software, and to permit persons to whom the Software
 is furnished to do so, subject to the following conditions:
 
 The above copyright notice and this permission notice shall be included
 in all copies or substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
 KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 DEALINGS IN THE SOFTWARE.
*/ 

DEF VAR t AS CHARACTER NO-UNDO.

OUTPUT TO BatTestCalculate.txt.

/* Make sure numbers sent don't blow it up */

ASSIGN T = "42".
MESSAGE "Evaluating " T.
RUN Calculate.p (INPUT T, OUTPUT T).
MESSAGE  T  SKIP.

/* Simple binary operation */

ASSIGN T = "2 + 4".
MESSAGE "Evaluating " T.
RUN Calculate.p (INPUT T, OUTPUT T).
MESSAGE  T  SKIP.

/* Verify Mult and div happen before add and sub */

ASSIGN T = "2 + 4 * 3".
MESSAGE "Evaluating " T.
RUN Calculate.p (INPUT T, OUTPUT T).
MESSAGE  T  SKIP.

/* Negative numbers work */

ASSIGN T = "2 + -4".
MESSAGE "Evaluating " T.
RUN Calculate.p (INPUT T, OUTPUT T).
MESSAGE  T  SKIP.

/* Grouping operators work in expected order */

ASSIGN T = " ( 2 + 4 ) * 3".
MESSAGE "Evaluating " T.
RUN Calculate.p (INPUT T, OUTPUT T).
MESSAGE  T  SKIP.

/* More complicated group */

ASSIGN T = " ( 2 + 4 ) * 3 * ( 7 + 3 ) ".
MESSAGE "Evaluating " T.
RUN Calculate.p (INPUT T, OUTPUT T).
MESSAGE  T  SKIP.

/* Nested group orders work */

ASSIGN T = " ( 2 + 4 * ( 3 + 3 ) ) * 3 * ( 7 + 3 ) ".
MESSAGE "Evaluating " T.
RUN Calculate.p (INPUT T, OUTPUT T).
MESSAGE  T  SKIP.

/* Take a shot at functions */

ASSIGN T = "Power[ ( 3 + 4 ) ,2 ]".
MESSAGE "Evaluating " T.
RUN Calculate.p (INPUT T, OUTPUT T).
MESSAGE  T  SKIP.

ASSIGN T = "2 * Power[ ( 3 + 4 ) ,2 ]".
MESSAGE "Evaluating " T.
RUN Calculate.p (INPUT T, OUTPUT T).
MESSAGE  T  SKIP.

ASSIGN T = "Power[ ( 3 + 4 ) ,2 ] * 2".
MESSAGE "Evaluating " T.
RUN Calculate.p (INPUT T, OUTPUT T).
MESSAGE  T  SKIP.

ASSIGN T = "Power[ 7,2 ] * 3".
MESSAGE "Evaluating " T.
RUN Calculate.p (INPUT T, OUTPUT T).
MESSAGE  T  SKIP.

ASSIGN T = "Power[ 7,3 ]".
MESSAGE "Evaluating " T.
RUN Calculate.p (INPUT T, OUTPUT T).
MESSAGE  T  SKIP.

ASSIGN T = "Power[ Power[ 2,2 ] ,4 ]".
MESSAGE "Evaluating " T.
RUN Calculate.p (INPUT T, OUTPUT T).
MESSAGE  T  SKIP.

/* Test new expression cleaner uper */

ASSIGN T = "((3+4)*5)/2".
MESSAGE "Evaluating " T.
RUN Calculate.p (INPUT T, OUTPUT T).
MESSAGE  T  SKIP.

ASSIGN T = "(2*(2+4))".
MESSAGE "Evaluating " T.
RUN Calculate.p (INPUT T, OUTPUT T).
MESSAGE  T  SKIP.

OUTPUT CLOSE.
