/*
 Copyright (c) 2002 Amduus Information Works, Inc.  
 scott_auge@yahoo.com sauge@amduus.com

 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the "Software"),
 to deal in the Software without restriction, including without limitation the
 rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 sell copies of the Software, and to permit persons to whom the Software
 is furnished to do so, subject to the following conditions:
 
 The above copyright notice and this permission notice shall be included
 in all copies or substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
 KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
 CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 DEALINGS IN THE SOFTWARE.
*/ 

FUNCTION AlgParm RETURNS CHARACTER
(INPUT cExpression AS CHARACTER,
 INPUT dValue      AS DECIMAL,
 INPUT cVarName    AS CHARACTER):

  RETURN REPLACE(cExpression, cVarName, STRING(dValue)).

END.


FUNCTION CleanExpr RETURNS CHARACTER (INPUT cExpression AS CHARACTER):

  DEF VAR cResult     AS CHARACTER NO-UNDO.

  /* All parenthesis need spaces around them */
  
  ASSIGN cResult = REPLACE(cExpression, "(", " ( ").
  ASSIGN cResult = REPLACE(cResult, ")", " ) ").
  
  /* All the +, * and / need spaces around them.  - is a seperate issue */
  /* so assume the user has clue about it's use as it means negative    */
  /* number also.                                                       */
  
  ASSIGN cResult = REPLACE(cResult, "+", " + ").
  ASSIGN cResult = REPLACE(cResult, "*", " * ").
  ASSIGN cResult = REPLACE(cResult, "/", " / ").
  
  /* All ] need spaces around them */
  
  ASSIGN cResult = REPLACE(cResult, "]", " ] ").
  
  /* All [ need a space behind them */
  
  ASSIGN cResult = REPLACE(cResult, "[", " [ ").
  
  /* The function beginning argument delimiter cannot have a space */
  /* in front of it.  In case there are multiple spaces in front,  */
  /* we loop until it is gone.                                     */
  
  REPEAT:
    IF INDEX(cResult, " [") <> 0 THEN
      ASSIGN cResult = REPLACE(cResult, " [", "[").
    ELSE
     LEAVE.
  END.
  
  /* Clear out double spaces and return the result */
  
  REPEAT:
    IF INDEX(cResult, "  ") <> 0 THEN
      ASSIGN cResult = REPLACE(cResult, "  ", " ").
    ELSE
     LEAVE.
  END.
 
  RETURN cResult.
 
END.

