/*
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


/* Creates a Horizontal Bar Chart.  Accepts list of integer values and */
/* plots them out in a series of boxes of iMaxWidth and iMaxHeight.    */
/* Entries should be between 0.0 - 1.0 to scale to dMaxWidth properly. */

&IF DEFINED(HORZBARCHART_I) <> 1 &THEN
&GLOBAL-DEFINE HORZBARCHART_I YEP

DEF VAR RCSVersionHORZBARCHART_I AS CHARACTER INIT "$Header: /home/appl/Denkh/src/RCS/HorzBarChart.i,v 3.0 2003/06/25 07:14:01 sauge Exp sauge $" NO-UNDO. 

PROCEDURE HorzBarChart:
  DEF INPUT PARAMETER cValuesList AS CHARACTER NO-UNDO.
  DEF INPUT PARAMETER cLabelList AS CHARACTER NO-UNDO.
  DEF INPUT PARAMETER fMaxWidth AS DECIMAL NO-UNDO.
  DEF INPUT PARAMETER fMaxHeight AS DECIMAL NO-UNDO.

  DEF VAR iCurrentEntry AS INTEGER NO-UNDO.
  DEF VAR cCurrentEntry AS CHARACTER NO-UNDO.
  DEF VAR cCurrentLabel AS CHARACTER NO-UNDO.
  DEF VAR fCurrentEntry AS DECIMAL NO-UNDO.
  DEF VAR fCurrentBoxWid AS DECIMAL NO-UNDO.
  DEF VAR iNumberEntry AS INTEGER NO-UNDO.
  DEF VAR cPositionInstructions AS CHARACTER NO-UNDO.
  DEF VAR cDrawBox AS CHARACTER NO-UNDO.

  ASSIGN 
  iNumberEntry = NUM-ENTRIES(cValuesList).



PUT STREAM StdOut UNFORMATTED '.PS~n'.
PUT STREAM StdOut UNFORMATTED 'down~n'.
ASSIGN cPositionInstructions = "".
DO iCurrentEntry = 1 TO iNumberEntry:
  ASSIGN cCurrentEntry = ENTRY(iCurrentEntry, cValuesList).
  ASSIGN fCurrentEntry = DECIMAL(cCurrentEntry).
  ASSIGN fCurrentBoxWid = fCurrentEntry * fMaxWidth.
  ASSIGN cCurrentLabel = ENTRY(iCurrentEntry, cLabelList).


PUT STREAM StdOut UNFORMATTED 'box ~"' cCurrentLabel '~" ht ' fMaxHeight ' wid ' fCurrentBoxWid ' ' cPositionInstructions '~n'.
  ASSIGN cPositionInstructions = "with .nw at last box.sw".
END. /* DO iCurrentEntry = 1 TO iNumberEntry */


PUT STREAM StdOut UNFORMATTED '.PE~n'.
END. /* PROCEDURE HorzBarChart */

&ENDIF

