/*
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


&IF DEFINED(INSERTIMAGE_I) <> 1 &THEN
&GLOBAL-DEFINE INSERTIMAGE_I YEP

{PostFix.i}
{FileName.i}

DEF VAR INSERTIMAGERCSVersion AS CHARACTER INIT "$Header: /home/appl/Denkh/src/RCS/InsertImage.i,v 3.0 2003/06/25 07:14:01 sauge Exp sauge $" NO-UNDO. 

/* 
   cAlign = L R (Blank)
   cFileName = path/name of file
   cXSize = size in inches
   cYSize = size in inches
*/

FUNCTION InsertImage RETURNS CHARACTER (INPUT cAlign AS CHARACTER,
                                        INPUT cFileName AS CHARACTER,
                                        INPUT cXSize AS CHARACTER,
                                        INPUT cYSize AS CHARACTER):

  DEF VAR cTempFileName AS CHARACTER NO-UNDO.
  DEF VAR cOSCommand    AS CHARACTER NO-UNDO.

  /* If the image is not encapsulated postscript (EPS) then we need to   */
  /* convert it into an EPS file.  We use the convert command that comes */
  /* with linux to achieve this.                                         */

  IF PostFix(cFileName) <> ".eps" THEN DO:
    ASSIGN 
    cTempFileName = cFileName + ".eps".
    cOSCommand = "convert " 
               + SEARCH(cFileName) + " " 
               + "/tmp/" + FileName(cTempFileName).
    OS-COMMAND VALUE(cOSCommand).
    ASSIGN cFileName = "/tmp/" + FileName(cTempFileName).
  END.

  RETURN "~n.PSPIC " + cAlign + " ~"" + cFileName  + "~" " + cXSize + " " + cYSize + "~n".

END.

&ENDIF

