
DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/Denkh/src/PDFClt/RCS/PDFSvrGet.p,v 1.1 2002/07/11 20:15:41 sauge Exp $" NO-UNDO.

DEF INPUT PARAMETER cFileName          AS CHARACTER NO-UNDO.
DEF INPUT PARAMETER cPDFReportID       AS CHARACTER NO-UNDO.
DEF OUTPUT PARAMETER cReportStatus     AS CHARACTER NO-UNDO.

{FileName.i}
{FilePath.i}

/* Determine if we can find the PDFReport record mentioned. */

IF NOT CAN-FIND(PDFReport WHERE PDFReport.PDFReportID = cPDFReportID) THEN DO:

  ASSIGN cReportStatus = "NO_RECORD".
  RETURN.

END.

/* Lets see if we can nab it */

FIND PDFReport EXCLUSIVE-LOCK 
WHERE PDFReport.PDFReportID = cPDFReportID
NO-ERROR NO-WAIT.

IF LOCKED PDFReport THEN DO:

  ASSIGN cReportStatus = "LOCKED".
  RETURN.

END.

/* Lets see if it is done by the PDF Server */

IF PDFReport.ReportStatus <> "DONE" THEN DO:

  ASSIGN cReportStatus = PDFReport.ReportStatus.
  RETURN.

END.

/* Looks like it is ours for the taking!  Process it. */

RUN file/RetrieveFile.p
(INPUT PDFReport.OutOSFileID,
 INPUT FileName(cFileName),
 INPUT FilePath (cFileName),
 OUTPUT cReportStatus).

ASSIGN cReportStatus = PDFReport.ReportStatus.

RELEASE PDFReport.

