

/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/Denkh/src/rptgen/RCS/Calc.p,v 3.0 2003/06/25 07:12:41 sauge Exp $" NO-UNDO. 

/* Find @calc() macros, update the appropriate record */

DEF INPUT PARAMETER cS AS CHARACTER NO-UNDO.
DEF OUTPUT PARAMETER cT AS CHARACTER NO-UNDO.

/* Go through the input looking for @calc()'s, take out the formula */
/* take out the format, replace the whole thing with the formula's  */
/* output. */

DEF VAR cB         AS CHARACTER NO-UNDO.
DEF VAR cSub       AS CHARACTER NO-UNDO.
DEF VAR cN1        AS CHARACTER NO-UNDO.
DEF VAR cN2        AS CHARACTER NO-UNDO.
DEF VAR cOpr       AS CHARACTER NO-UNDO.
DEF VAR cCalc      AS CHARACTER NO-UNDO.
DEF VAR cFormula   AS CHARACTER NO-UNDO.
DEF VAR cFormat    AS CHARACTER NO-UNDO.

{rptgen/MacroArg.i}

ASSIGN cT = cS.

/* Repeat from the left to the right looking for @calc to replace */
  
REPEAT:
      
    /* IF there is no holder, THEN leave */
     
   IF INDEX (cT, "@calc(") = 0 THEN LEAVE.

   /* Look up the arguments to a @calc */
   ASSIGN cB = MacroArg(cT,"@calc").     

   /* Calc out the value */
   /* Note this is part of the EQN package.  I have it in */
   /* /appl/eqn/src and that is part of the PROPATH.      */
   /* Note that the formula is argument 1, and the format */
   /* is argument 2.                                      */

   RUN Calculate.p (INPUT ENTRY(1,cB), OUTPUT cCalc).
   ASSIGN cCalc = STRING(DECIMAL(cCalc), ENTRY(2,cB)).

   /* Replace the macro with the value */

   ASSIGN cSub = "@calc(" + cB + ")".
   ASSIGN cT = REPLACE (cT, cSub, cCalc).

END. /* REPEAT: */


