/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/Denkh/src/rptgen/RCS/EmbSub.p,v 3.1 2003/07/11 04:23:13 sauge Exp sauge $" NO-UNDO. 

/* Find @emb() macros, run the named program with the given inputs, remove */
/* macro from record text.                                                 */

DEF INPUT PARAMETER cSessionID AS CHARACTER NO-UNDO.
DEF INPUT PARAMETER cS AS CHARACTER NO-UNDO.
DEF OUTPUT PARAMETER cT AS CHARACTER NO-UNDO.

DEF VAR cB         AS CHARACTER NO-UNDO.
DEF VAR cSub       AS CHARACTER NO-UNDO.
DEF VAR cPrg       AS CHARACTER NO-UNDO.
DEF VAR cPrgArg    AS CHARACTER NO-UNDO.
DEF VAR cPrgOutPut AS CHARACTER NO-UNDO.
 
ASSIGN cT = cS.
  
REPEAT:
      
    /* If there is no holder, then leave */
     
   IF INDEX (cT, "@emb(") = 0 THEN LEAVE.
     
   ASSIGN cB = SUBSTRING (cT, INDEX (cT, "@emb(") + 5).
          cB = SUBSTRING (cB, 1, INDEX(cB, ")") - 1).

   /* Remember the string so we can do a big REPLACE on it */

   ASSIGN cSub = "@emb(" + cB + ")".

   /* Program is the first argument */
 
   cPrg = ENTRY(1, cB).

   cPrgArg = ENTRY(2, cB).

   /* Go run the embedded report.  These are known by their */
   /* names, not their RptTemplate1ID values.               */

   RUN rptgen/RunEmbedHTMLRpt.p (INPUT cSessionID, INPUT cPrg, INPUT cPrgArg, OUTPUT cPrgOutPut).

   /* Go do a big search and replace on the the emb */
   /* with blanks to remove it from the record.     */

   cT = REPLACE (cT, cSub, cPrgOutPut).

END. /* REPEAT: */


