/*E4GL-I*/ {&OUT} '<META NAME="wsoptions" CONTENT="include">~n'.
 /*Tag=<!--WSS*/ 
/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

/* This is HTMLRpt.html with the GET-VALUES taken out.  Basically it */
/* accepts a string containing the parameters to be sent to the re-  */
/* port.   It is expected be called via the @emb() macro which has   */
/* the following arguments:                                          */
/*    @emd(ReportName,Parameters)                                    */
/* where                                                             */
/*   ReportName is the report title                                  */
/*   Parameters is a | delimited list of parameters in the cor-      */
/*   rect order for any @inp() arguments.                            */
/*                                                                   */
/* For example:  @emd(ZipCode,Flint|MI)                              */


DEF VAR Embed_RCSVersion AS CHARACTER INIT "$Header: /home/appl/Denkh/src/rptgen/RCS/EmbedHTMLRpt.i,v 3.1 2003/07/11 04:23:13 sauge Exp sauge $" NO-UNDO.

/* For webspeed, we need to include e4gl.i to get our {&OUT} definition */
/* Blue Diamond needs something else.                                   */

/* Was trying to merge streams, but need a new strategy.  One runs the re- */
/* port hoping that it doesn't go over 32K in size, and send it back as an */
/* argument for substitution into the real report.                         */

/*
/*E4GL-W*/ {src/web/method/cgidefs.i}
*/

&GLOBAL-DEFINE OUT PUT STREAM StdOut UNFORMATTED

DEF INPUT PARAMETER cSessionID AS CHARACTER NO-UNDO.
DEF INPUT PARAMETER cRptName AS CHARACTER NO-UNDO.
DEF INPUT PARAMETER cArgs AS CHARACTER NO-UNDO.
DEF OUTPUT PARAMETER cOut AS CHARACTER NO-UNDO.

/* Sometimes people make reports with the same name.  Use */
/* the first one we can find.                             */

FIND FIRST RptTemplate1 NO-LOCK
WHERE RptTemplate1.Name = cRptName
NO-ERROR.

/* Sometimes people are not good with remembering report */
/* names.  If we cannot find the report, then bail outta */
/* here.                                                 */

IF NOT AVAILABLE RptTemplate1 THEN RETURN.

{MakeID3.i}

/* User data inputs */

DEF VAR cQuery        AS CHARACTER NO-UNDO.
DEF VAR cBufferList   AS CHARACTER NO-UNDO.
DEF VAR cFieldList    AS CHARACTER NO-UNDO.
DEF VAR cColumnLabels AS CHARACTER NO-UNDO.

DEF VAR cPageHeader   AS CHARACTER NO-UNDO.
DEF VAR cPageFooter   AS CHARACTER NO-UNDO.
DEF VAR cRecord       AS CHARACTER NO-UNDO.
DEF VAR cSummary      AS CHARACTER NO-UNDO.

DEF VAR i AS INTEGER NO-UNDO.
DEF VAR iRowCount AS INTEGER NO-UNDO.

DEF VAR cFieldValue     AS CHARACTER NO-UNDO.
DEF VAR cRptTemplate1ID AS CHARACTER NO-UNDO.
DEF VAR iNumberInputs   AS INTEGER NO-UNDO.
DEF VAR cUserInput      AS CHARACTER NO-UNDO.

DEF VAR cErrorReport    AS CHARACTER NO-UNDO.

/* Used by @dur() */

DEF VAR iStartTime AS INTEGER NO-UNDO.
ASSIGN iStartTime = TIME.

/* Here we define one query the page can show.  It can have 18 tables */
/* and of each table, can display 50 fields of that table.            */

DEF VAR hTheQuery AS HANDLE NO-UNDO.

/* Keep a list of tables in the query */

DEF NEW SHARED TEMP-TABLE QueryTables
  FIELD hBuffer       AS HANDLE
  FIELD TableName     AS CHARACTER
  FIELD QueryOffset   AS INTEGER
  INDEX key1 IS PRIMARY TableName.

/* Keep a list of the fields for the query tables */

DEF NEW SHARED TEMP-TABLE QueryFields
  FIELD TableName AS CHARACTER 
  FIELD FieldName AS CHARACTER
  FIELD hField AS HANDLE
  FIELD Order AS INTEGER 
  INDEX key1 IS PRIMARY TableName.

/* Used in debugging code below */

DEF VAR hBuffer AS HANDLE.

/* Status Flags */

DEF VAR lStatusFlag AS LOGICAL NO-UNDO.

DEF VAR cTmpFile AS CHARACTER NO-UNDO.
DEF VAR lLine    AS CHARACTER NO-UNDO.

/* Pull in the sessionid if there is any! */

DEF STREAM StdOut.

/* Where we are sending the report to and will scoop up into a string */
/* when we end this whole thing.                                      */

ASSIGN cTmpFile = SESSION:TEMP-DIRECTORY + MakeID3(10).

OUTPUT STREAM StdOut TO VALUE(cTmpFile).

/* Get the facts we are working with.                                 */
/* For more secure queries, we will need to pull them from a database */
/* state table instead of from the URL, but hey - trying to get it    */
/* working!                                                           */

ASSIGN
iNumberInputs = NUM-ENTRIES(cArgs, "|").

ASSIGN
cQuery = RptTemplate1.RptQuery
cRecord = RptTemplate1.Record
cColumnLabels = RptTemplate1.Substitution
cPageHeader = RptTemplate1.PageHeader
cSummary = RptTemplate1.Summary
cPageFooter = RptTemplate1.PageFooter.


/* Before we do anything, lets make sure security is cool. */

RUN rptgen/SubSecure.p 
(INPUT cSessionID,
 INPUT cPageHeader,
 OUTPUT cPageHeader,
 OUTPUT cErrorReport).

IF cErrorReport <> "" THEN DO:

  FIND RptTemplate1 NO-LOCK
  WHERE RptTemplate1.Name = cErrorReport
  NO-ERROR.

  IF NOT AVAILABLE RptTemplate1 THEN DO:
 /*Tag=-->*/ 
{&OUT} '    <html>~n'.
{&OUT} '    <p>Attempting to run report titled "' /*Tag=`*/ cErrorReport /*Tag=`*/ '" but cannot find it!</p>~n'.
{&OUT} '    </html>~n'.
 /*Tag=<!--WSS*/ 
    RETURN.
  END.  /* IF NOT AVAILABLE RptTemplate */
  ELSE DO:
 /*Tag=-->*/ 
{&OUT} '    <html>~n'.
{&OUT} '    <header>~n'.
{&OUT} '          <META HTTP-EQUIV="REFRESH" CONTENT="0~; URL=HTMLRpt.html?RptTemplate1ID=' /*Tag=`*/ RptTemplate1.RptTemplate1ID /*Tag=`*/ '">~n'.
{&OUT} '    </header>~n'.
{&OUT} '    </html>~n'.
 /*Tag=<!--WSS*/ 
    RETURN.
  END.

END. /* IF cErrorReport <> "" */

/* MESSAGE "1 cQuery= " cQuery. */

/* Process substitions in the query with the inputs from the user */

DO i = 1 TO iNumberInputs:

  ASSIGN cUserInput = ENTRY(i, cArgs, "|").

 /* {&OUT} "Working on: " cUserInput " of " cArgs " <br>".
 {&OUT} "Query : " cQuery " <br>".   */

  RUN rptgen/PrcQuery.p (cQuery, cUserInput, OUTPUT cQuery).

END. /* DO i = 1 TO iNumberInputs */

/* MESSAGE "2 cQuery= " cQuery. */

/* We can get our buffer list (ordered) from the query with qrytbls.p  */

RUN rptgen/qrytbls.p (INPUT cQuery, OUTPUT cBufferList).

/* --------------------------------------------------------------
{&OUT} "Query: " cQuery "<br>".
{&OUT} "Buffer List: " cBufferList.
 -------------------------------------------------------------- */

/* Pull in our field list from the Record template definition */

RUN rptgen/IDFields.p (INPUT cRecord, OUTPUT cFieldList).

/* Process the page header and page footers for any macros */

RUN rptgen/PrcMacro.p (INPUT cPageHeader, OUTPUT cPageHeader).
RUN rptgen/PrcMacro.p (INPUT cPageFooter, OUTPUT cPageFooter).

RUN rptgen/SubRptName.p (INPUT cPageHeader, INPUT RptTemplate1.Name, OUTPUT cPageHeader).
RUN rptgen/SubRptName.p (INPUT cPageFooter, INPUT RptTemplate1.Name, OUTPUT cPageFooter).

/* Handle any @inp() macros in the Header and Footer */

DO i = 1 TO iNumberInputs:

  ASSIGN cUserInput = ENTRY(i, cArgs, "|").
  RUN rptgen/InpSub.p (cPageHeader, STRING(i), cUserInput, OUTPUT cPageHeader).
  RUN rptgen/InpSub.p (cPageFooter, STRING(i), cUserInput, OUTPUT cPageFooter).

END. /* DO i = 1 TO iNumberInputs */


/* Since we have @date()... in @prg(), we call this AFTER the sub-  */
/* stitutions have been done.  We should have strings of data   */
/* where the @fld() use to be.                                  */

/* Process @sessionid() because it is likely to be used for @prg() */

RUN rptgen/SubSessionID.p (INPUT cPageHeader, INPUT cSessionID, OUTPUT cPageHeader).
RUN rptgen/SubSessionID.p (INPUT cPageFooter, INPUT cSessionID, OUTPUT cPageFooter).

/* This program processes @prg() macros */

RUN rptgen/PrgSub.p (INPUT cPageHeader, OUTPUT cPageHeader).
RUN rptgen/PrgSub.p (INPUT cPageFooter, OUTPUT cPageFooter).

/* Process @fmt() macros */

RUN rptgen/NFmt.p (INPUT cPageHeader, OUTPUT cPageHeader).
RUN rptgen/NFmt.p (INPUT cPageFooter, OUTPUT cPageFooter).

/* Process the @drill() macros */

RUN rptgen/Drill.p (INPUT cPageHeader, OUTPUT cPageHeader).
RUN rptgen/Drill.p (INPUT cPageFooter, OUTPUT cPageFooter).

/* This program processes @emb() macros.  Note this allows us to */
/* do multiple embedded reports.                                 */

RUN rptgen/EmbSub.p (INPUT cSessionID, INPUT cPageHeader, OUTPUT cPageHeader).
RUN rptgen/EmbSub.p (INPUT cSessionID, INPUT cPageFooter, OUTPUT cPageFooter).

/* This routine finds out what tables were sent in to the procedure.  It */
/* then creates a handle for that table.  It places that handle, as well */
/* the table name and the offset in the query:get-buffer-handle() it can */
/* be found in into a tenp table record so we can fiddle around with em. */


DO i = 1 TO NUM-ENTRIES(cBufferList):

  /* Determine if the entry is a table name, or a named buffer for a */
  /* table.  The create buffer depends on some look ups if a named   */
  /* buffer.                                                         */

  IF CAN-FIND(RptBuffer WHERE RptBuffer.BufName = ENTRY(i,cBufferList)
                          AND RptBuffer.TableName = ENTRY(i,cBufferList))
  THEN DO:

    CREATE BUFFER hBuffer FOR TABLE ENTRY(i,cBufferList).

  END.

  ELSE DO:

    FIND RptBuffer NO-LOCK
    WHERE RptBuffer.BufName = ENTRY(i,cBufferList).

    CREATE BUFFER hBuffer FOR TABLE RptBuffer.TableName BUFFER-NAME RptBuffer.BufName.

  END.

  CREATE QueryTables.
  ASSIGN QueryTables.TableName =  ENTRY(i,cBufferList)
         QueryTables.hBuffer = hBuffer
         QueryTables.QueryOffset = i.

END. /* DO i = 1 TO NUM-ENTRIES(cBufferList */

/* This routine creates temp table entries for each field that will be */
/* looked up from the query.  These fields are tied to the QueryTables */
/* table to match fields to buffer later on.                           */


DO i = 1 TO NUM-ENTRIES(cFieldList):

  CREATE QueryFields.
  ASSIGN QueryFields.TableName = ENTRY(1,ENTRY(i,cFieldList), ".")
         QueryFields.FieldName = ENTRY(2,ENTRY(i,cFieldList), ".").
         QueryFields.Order = i.

END. /* DO i 1 TO NUM-ENTRIES(cFieldList) */

 /*Tag=-->*/ 
{&OUT} /*Tag=`*/ cPageHeader /*Tag=`*/ .
 /*Tag=<!--WSS*/ 

/* Create us a query to run against the DB */

/* MESSAGE "cQuery" cQuery. */

IF cQuery <> "" THEN DO: 

  CREATE QUERY hTheQuery.

  /* Attach our buffers to the query so something is there */
  FOR EACH QueryTables BY QueryOffset:
    hTheQuery:ADD-BUFFER(QueryTables.hBuffer).
  END. /* FOR EACH QueryTables BY QueryOffset */

  /* Now that we have the data structures ready, call out to */
  /* to the DB.                                              */

  ASSIGN lStatusFlag = hTheQuery:QUERY-PREPARE(cQuery).

  IF lStatusFlag = FALSE THEN DO:
    {&OUT} "Prepare FAILED!<br>".
  END.

  ASSIGN lStatusFlag = hTheQuery:QUERY-OPEN().

  IF lStatusFlag = FALSE THEN DO:
    {&OUT} "Open FAILED!<br>".
    {&OUT} "Date: " TODAY "&nbsp;" STRING(TIME, "HH:MM:SS") "<br>".
    {&OUT} "Report Name: " RptTemplate1.Name "<br>".
    {&OUT} "cBufferList: " cBufferList "<br>".
    /* Begin Used for debugging */ 
    REPEAT i = 1 TO hTheQuery:NUM-BUFFERS:
      hBuffer = hTheQuery:GET-BUFFER-HANDLE(i).
      {&OUT} "Query Has Buffer: " hBuffer:NAME "<br>". 
    END.

    FOR EACH QueryFields BY Order:
      {&OUT} "Query Field: " QueryFields.TableName 
           " " QueryFields.FieldName "<br>".
    END.
    {&OUT} cQuery.
    {&OUT} "<hr><br>".

  END. /* IF lStatusFlag = FALSE */

  /* Prep var to prevent run away agent */
  ASSIGN iRowCount = 0.

  /* Throw the goods into a table for formatting */
 /*Tag=-->*/ 
 /*Tag=<!--WSS*/ 
/* This shall be controlled by a report designer
  <table width="100%" align="center" border="0">
*/
 /*Tag=-->*/ 

 /*Tag=<!--WSS*/ 
  IF cColumnLabels <> "" THEN DO: 
 /*Tag=-->*/ 
{&OUT} '    <tr bgcolor="#CCCCCC">~n'.
 /*Tag=<!--WSS*/ 
    /* Put out the column labels */
    DO i = 1 TO NUM-ENTRIES (cColumnLabels):
 /*Tag=-->*/ 
{&OUT} '      <td><font>' /*Tag=`*/ ENTRY(i, cColumnLabels) /*Tag=`*/ '</font></td>~n'.
 /*Tag=<!--WSS*/ 
    END. /* DO i = 1 TO NUM-ENTRIES (cColumnLabels) */
 /*Tag=-->*/ 
{&OUT} '    </tr>~n'.
 /*Tag=<!--WSS*/ 
  END.
 /*Tag=-->*/ 


 /*Tag=<!--WSS*/ 
  /* Begin processing the query pulling up the goods */

  IF lStatusFlag <> FALSE THEN  REPEAT:

    hTheQuery:GET-NEXT.
    IF (hTheQuery:QUERY-OFF-END) THEN LEAVE.

    ASSIGN iRowCount = iRowCount + 1.
    IF iRowCount > RptTemplate1.MaxRowCount THEN LEAVE.

    /* Start pulling out the data and placing it into the output */
 /*Tag=-->*/ 
 /*Tag=<!--WSS*/ 

      /* Here we process the record template, substituting the fields */
      /* with the field data via the @fld(table.fieldname) macro.     */

      /* Reassign the template from the report definition */

      ASSIGN cRecord = RptTemplate1.Record.

      /* Substitute in the field names */

      FOR EACH QueryFields BY Order:

        FIND QueryTables 
        WHERE QueryTables.TableName = QueryFields.TableName.

        hField = QueryTables.hBuffer:BUFFER-FIELD(QueryFields.FieldName).

        /* We always need to perform field subs first in case   */
        /* macro (processed below) needs the value to work with */

        ASSIGN cFieldValue = hField:BUFFER-VALUE.
        IF cFieldValue = "" THEN ASSIGN cFieldValue = "&nbsp;".
        IF cFieldValue = ? THEN ASSIGN cFieldValue = "&nbsp;".

        /* This program process @fld() macros */

        RUN rptgen/FldSub.p
        (INPUT cRecord,
         INPUT QueryFields.TableName + "." + QueryFields.FieldName,
         INPUT STRING(cFieldValue),
         OUTPUT cRecord
        ).

      END. /* FOR EACH QueryFields OF QueryTables: */


     /* Process any @row() macros */

     /* {&OUT} "SETTING ROWIDS:". */
     REPEAT i = 1 TO hTheQuery:NUM-BUFFERS:
       hBuffer = hTheQuery:GET-BUFFER-HANDLE(i).

       /* {&OUT} "Buffer: " hBuffer:Name 
                  " ROWID " STRING(hBuffer:ROWID) "<br>". */

        RUN rptgen/RowSub.p
        (INPUT cRecord,
         INPUT hBuffer:Name,
         INPUT STRING(hBuffer:ROWID),
         OUTPUT cRecord
        ).
      END.

      /* Handle @rptname() in records in case page breaking */

      RUN rptgen/SubRptName.p 
      (INPUT cRecord, 
       INPUT RptTemplate1.Name, 
       OUTPUT cRecord).

      /* Process the @time() and @date() macros in the report record  */

      RUN rptgen/PrcMacro.p (INPUT cRecord, OUTPUT cRecord).

      /* Handle any @inp() macros in the record */

      DO i = 1 TO iNumberInputs:

        ASSIGN cUserInput = ENTRY(i, cArgs, "|").
        RUN rptgen/InpSub.p (cRecord, STRING(i), cUserInput, OUTPUT cRecord).

      END. /* DO i = 1 TO iNumberInputs */

      /* Handle @sessionid() macros before @prg() because most likely */
      /* used there.                                                  */

      RUN rptgen/SubSessionID.p (INPUT cRecord, INPUT cSessionID, OUTPUT cRecord).

      RUN rptgen/PrgSub.p (INPUT cRecord, OUTPUT cRecord).

      /* Perform @calc()'s */

      RUN rptgen/Calc.p(INPUT cRecord, OUTPUT cRecord).

      /* Call out to the macro's that handle sub-totalling.  */

      RUN rptgen/TrkSubTotal.p (INPUT cRecord, OUTPUT cRecord).
      RUN rptgen/RptSubTotal.p (INPUT cRecord, OUTPUT cRecord).
      RUN rptgen/TblSubTotal.p (INPUT cRecord, OUTPUT cRecord).

      /* Run the @fmt() macro */

      RUN rptgen/NFmt.p (INPUT cRecord, OUTPUT cRecord).


      /* Process the @drill() macro */

      RUN rptgen/Drill.p (INPUT cRecord, OUTPUT cRecord).

      /* This program processes @emb() macros */

       RUN rptgen/EmbSub.p (INPUT cSessionID, INPUT cRecord, OUTPUT cRecord).


 /*Tag=-->*/ 
{&OUT} /*Tag=`*/ cRecord /*Tag=`*/ .
 /*Tag=<!--WSS*/ 
  END. /* REPEAT */

  /* Call out to the macro's that handle sub-totalling.  */

  RUN rptgen/TrkSubTotal.p (INPUT cSummary, OUTPUT cSummary).
  RUN rptgen/RptSubTotal.p (INPUT cSummary, OUTPUT cSummary).
  RUN rptgen/TblSubTotal.p (INPUT cSummary, OUTPUT cSummary).

  /* Run the @fmt() macro */

  RUN rptgen/NFmt.p (INPUT cSummary, OUTPUT cSummary).

  /* Run the @drill() macros */

  RUN rptgen/Drill.p (INPUT cSummary, OUTPUT cSummary).

  /* This program processes @emb() macros */

  RUN rptgen/EmbSub.p (INPUT cSessionID, INPUT cSummary, OUTPUT cSummary).

 /*Tag=-->*/ 

{&OUT} /*Tag=`*/ cSummary /*Tag=`*/ .

 /*Tag=<!--WSS*/ 
/* This shall be controlled by the report designer
  </table>
*/
 /*Tag=-->*/ 

 /*Tag=<!--WSS*/ 

  hTheQuery:QUERY-CLOSE.
END. /* IF cQuery <> "" */

/* Compute Duration of report - @dur() can be only used in the page footer */

RUN rptgen/DurSub(INPUT cPageFooter, INPUT iStartTime, OUTPUT cPageFooter).
 /*Tag=-->*/ 

{&OUT} /*Tag=`*/ cPageFooter /*Tag=`*/ .

 /*Tag=<!--WSS*/ 
IF iRowCount > RptTemplate1.MaxRowCount AND RptTemplate1.ShowWarning THEN DO:
 /*Tag=-->*/ 
{&OUT} '<center>WARNING: Max Row Count of ' /*Tag=`*/ RptTemplate1.MaxRowCount /*Tag=`*/ ' exceeded.  Not all data is on this report!  To increase MaxRowCount, re-edit report definition.</center>~n'.
 /*Tag=<!--WSS*/ 
END.
 /*Tag=-->*/ 

 /*Tag=<!--WSS*/ 

/* Housekeeping */

IF cQuery <> "" THEN DO:

  DELETE OBJECT hTheQuery.

END.

  FOR EACH QueryTables:

    DELETE OBJECT QueryTables.hBuffer.

  END.

/* Need this carriage return for the REPEAT below, else we */
/* won't pick up the final line.  Crazy Quirk work around. */

{&OUT} "~n".

OUTPUT STREAM StdOut CLOSE.

/* Now that we have the report stored in a file, we re-open */
/* the file and read it into a varible.  We then send that  */
/* back to the calling program so it can substitute it for  */
/* the @emb() macro.                                        */

INPUT STREAM StdOut FROM VALUE(cTmpFile).

REPEAT:

  IMPORT STREAM StdOut UNFORMATTED lLine.

  ASSIGN cOut = cOut + lLine.

END.


INPUT STREAM StdOut CLOSE.

OS-DELETE VALUE(cTmpFile).

 /*Tag=-->*/ 



/************************* END OF HTML *************************/
/*
** File: /home/appl/Denkh/src/rptgen/EmbedHTMLRpt.i
** Generated on: 2003-07-10 21:15:11
** By: WebSpeed Embedded SpeedScript Preprocessor
** Version: 2
** Source file: /home/appl/Denkh/src/rptgen/EmbedHTMLRpt.html
** Options: include,wsoptions-found
**
** WARNING: DO NOT EDIT THIS FILE.  Make changes to the original
** HTML file and regenerate this file from it.
**
*/

/* end */
