

/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/Denkh/src/rptgen/RCS/NFmt.p,v 3.0 2003/06/25 07:12:41 sauge Exp $" NO-UNDO. 

/* Fix: Scott Auge -- Amduus Information Works, Inc.
   June 16, 2003
   When a string is sent to fmt(), and that string contains a
   comma, this program got confused about where to find the
   formatting instructions.
   To correct this, the program will always look at the LAST
   argument for it's formatting, this way strings with , can
   be sent in.
   Fixed problem with sending in matching () in string and format 
   syntax.
*/

DEF INPUT PARAMETER cS AS CHARACTER NO-UNDO.
DEF OUTPUT PARAMETER cT AS CHARACTER NO-UNDO.

DEF VAR cB         AS CHARACTER NO-UNDO.
DEF VAR cSub       AS CHARACTER NO-UNDO.
DEF VAR cPrg       AS CHARACTER NO-UNDO.
DEF VAR cPrgArg    AS CHARACTER NO-UNDO.
DEF VAR cPrgOutPut AS CHARACTER NO-UNDO.
DEF VAR iNumPrgArg AS INTEGER NO-UNDO.
DEF VAR iParanCnt  AS INTEGER NO-UNDO.
DEF VAR iCurPos    AS INTEGER NO-UNDO.
DEF VAR cCurChar   AS CHARACTER NO-UNDO.
DEF VAR cC         AS CHARACTER NO-UNDO.
 
ASSIGN cT = cS
       iParanCnt = 0.
  
REPEAT:
      
    /* If there is no holder, then leave */
     
   IF INDEX (cT, "@fmt(") = 0 THEN LEAVE.
   
   /* Rewrite this so that we can include () in the string sent to this */
   /* function.                                                         */

   /* Find out where in the incoming string the @fmt( is */
 
   ASSIGN iCurPos = INDEX (cT, "@fmt(") + 5.

   /* Save up after that portion - it should include the string to */
   /* to format, as well the closing paranthesis (and other stuff  */
   /* in the record.  We want to use this later on to perform a    */
   /* REPLACE.                                                     */
 
   ASSIGN cB = SUBSTRING (cT, iCurPos).

/* disp cB. */

   /* We need to find the closing paranthesis to the @fmt(.  This is  */
   /* kinda tricky, cuz we might have a set of paranthesis as part of */
   /* the string to format.  We do this by counting the number of (   */
   /* we encounter, incrementing iParanCnt.  When we meet a closing ) */
   /* we decrement iParanCnt.  If we meet a ) and iParanCnt = 0, it   */
   /* should be the closing paranthesis for @fmt(.                    */

   ASSIGN cC = "".
   DO iCurPos = 1 TO LENGTH(cB):
/* disp cC. */
     ASSIGN cCurChar = SUBSTRING(cB, iCurPos, 1).
/* disp cCurChar. */
     IF cCurChar = "(" THEN ASSIGN iParanCnt = iParanCnt + 1.

     IF cCurChar = ")" THEN DO:
       IF iParanCnt > 0 THEN iParanCnt = iParanCnt - 1.
       ELSE LEAVE.
     END.

     ASSIGN cC = cC + cCurChar.

   END.  /* DO iCurPos = 1 TO LENGTH(cB) */

   /* Remember the string so we can do a big REPLACE on it */

   ASSIGN cB = cC.
/* disp cB format "x(30)" with frame a. */
   ASSIGN cSub = "@fmt(" + cB + ")".

   ASSIGN iNumPrgArg = NUM-ENTRIES(cB).

   /* String to format is arguments 1 - n - 1 cuz we don't know how */
   /* how many , might be tucked away in there!                     */

   DO iCurPos = 1 TO NUM-ENTRIES(cB) - 1: 
     ASSIGN cPrg = cPrg + ENTRY(iCurPos, cB) + ",".
   END.
   ASSIGN cPrg = SUBSTRING(cPrg, 1, LENGTH(cPrg) - 1).

   /* Argument to the program is the final argument.  We do this cuz */
   /* the string coming in to be formatted, might include a , which  */
   /* ENTRY() uses to figure out which arguments are which.          */

   /* NOTE:  If adding a new argument, they should come after the    */
   /* format string so that we can work backwards instead of forward */
   /* (since we don't know if the string to be formatted has a , or  */
   /* not.                                                           */

   ASSIGN cPrgArg = ENTRY(iNumPrgArg, cB).

   /* Send out the output according to the format */

   IF INDEX(cPrgArg,"HH:") <> 0 THEN
     ASSIGN cPrgOutPut = STRING(INT(cPrg),cPrgArg).

   ELSE IF INDEX(cPrgArg,"X") <> 0 THEN
     ASSIGN cPrgOutPut = STRING(cPrg,cPrgArg).

   ELSE 
     ASSIGN cPrgOutPut = STRING(DECIMAL(cPrg),cPrgArg).

   /* Go do a big search and replace on the the prg */
   /* with it's output.                             */

   cT = REPLACE (cT, cSub, cPrgOutPut).

END. /* REPEAT: */


