/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR PLCDescription_IRCSVersion AS CHARACTER INIT "$Header: /home/appl/Denkh/src/rptgen/RCS/PlcDescription.i,v 3.0 2003/06/25 07:12:41 sauge Exp $" NO-UNDO. 

FUNCTION PlcDescription RETURNS CHARACTER 
(
INPUT cS AS CHARACTER,
INPUT iP AS INTEGER
):

  DEF VAR j AS INTEGER NO-UNDO.
  DEF VAR cT AS CHARACTER NO-UNDO.
  DEF VAR cB AS CHARACTER NO-UNDO.

  ASSIGN cT = cS
         j = 0.

  REPEAT:

      /* If there is no holder, then return ? */

     IF INDEX (cT, "@plc(") = 0 THEN RETURN ?.
 
     /* We found one, is it the right one? */

     ASSIGN j = j + 1.

     /* It is the right one, pull out the contents between */
     /* the ( and ) characters.  Then we return the first  */
     /* comma delimited entry cuz that is the description. */

     IF j = iP THEN DO:
       ASSIGN cB = SUBSTRING (cT, INDEX (cT, "@plc(") + 5).
              cB = SUBSTRING (cB, 1, INDEX(cB, ")") - 1).
       RETURN ENTRY(1,cB).
     END. /*  IF j = iP */

     /* Move past the placeholders we don't need */

     ASSIGN cT = SUBSTRING(cT, INDEX (cT, "@plc(") + 1).

  END. /* REPEAT: */
     
END. /* FUNCTION PlcDescription() */

