/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */


DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/Denkh/src/rptgen/RCS/PrcQuery.p,v 3.0 2003/06/25 07:12:41 sauge Exp $" NO-UNDO.

/* Replace @plc()'s with user inputs.  Should be called in */
/* order of user input replacements.  Don't replace a plc  */
/* with something containing @plc( cuz it will bomb out!   */

  DEF INPUT PARAMETER cQuery     AS CHARACTER NO-UNDO.
  DEF INPUT PARAMETER cUserInput AS CHARACTER NO-UNDO.
  DEF OUTPUT PARAMETER cNewQuery AS CHARACTER NO-UNDO.

  DEF VAR iStoppingPoint AS INTEGER NO-UNDO.

  ASSIGN iStoppingPoint =  INDEX(cQuery, "@plc(").

  /* IF the query is empty, or plc() is not found, then we  */
  /* need to bail right pronto, other wise it will plop an  */
  /* input into the query even when we don't want it there! */

  IF iStoppingPoint = 0 THEN DO:
    ASSIGN cNewQuery = cQuery.
    RETURN.
  END.

  /* Load cNewQuery with strings up to the @plc( marker */
  ASSIGN cNewQuery = SUBSTRING (cQuery, 1, iStoppingPoint - 1).

  /* Tag in the User Input */
  ASSIGN cNewQuery = cNewQuery + cUserInput.

  /* Pull in the rest of the query starting at the ) of the @plc() */
  ASSIGN cQuery = SUBSTRING(cQuery, iStoppingPoint).
  ASSIGN iStoppingPoint = INDEX(cQuery, ")") + 1.
  ASSIGN cQuery = SUBSTRING(cQuery, iStoppingPoint).

  /* Tag rest of the query on so it can be further processed */
  ASSIGN cNewQuery = cNewQuery + cQuery.

