/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/Denkh/src/rptgen/RCS/SubSecure.p,v 1.1 2003/07/11 04:23:13 sauge Exp sauge $" NO-UNDO. 

/* Implement the @secure() macro. This macro should be use in the */
/* page header of a report template.                              */

DEF INPUT PARAMETER cSessionID      AS CHARACTER NO-UNDO.
DEF INPUT PARAMETER cIntext         AS CHARACTER NO-UNDO.
DEF OUTPUT PARAMETER cOutText       AS CHARACTER NO-UNDO.

/* When cErrorReport is "", then the report should run as usual. */
/* When not, it will contain the name of the report to actually  */
/* run.  This should be a failure message, or whatever the       */
/* report designer wants it to be.                               */

DEF OUTPUT PARAMETER cErrorReport   AS CHARACTER NO-UNDO.

DEF VAR cLogin                      AS CHARACTER NO-UNDO.
DEF VAR cGroupList                  AS CHARACTER NO-UNDO.

DEF VAR cB                          AS CHARACTER NO-UNDO.
DEF VAR cRptSub                     AS CHARACTER NO-UNDO.  
DEF VAR iOffset                     AS INTEGER NO-UNDO.

DEF VAR lIsGroupMember              AS LOGICAL NO-UNDO.

/* First determine if @secure( is actually in it!       */

ASSIGN cOutText = cInText.
ASSIGN cErrorReport = "".     
IF INDEX(cIntext, "@secure(") = 0 THEN RETURN.

/* Pull out the @secure() macro.  Note this doesn't like ( and ) */
/* in the report name and the security groups allowed to view it */

ASSIGN iOffset = INDEX(cOutText, "@secure(") + LENGTH("@secure(").
ASSIGN cB = SUBSTRING(cOutText, iOffset).
ASSIGN iOffset = INDEX(cB, ")") - 1.
ASSIGN cB = SUBSTRING(cB, 1, iOffset).

ASSIGN cRptSub = "@secure(" + cB + ")".

ASSIGN cGroupList = ENTRY(1, cB).
ASSIGN cErrorReport = ENTRY(2, cB).

/* Find the user running a report with @secure() in it. */

RUN state/ReadState.p (INPUT cSessionID,
                       INPUT "Denkh.Identification",
                       INPUT "Login",
                       OUTPUT cLogin).

FIND SecUser NO-LOCK
WHERE SecUser.Login = cLogin
NO-ERROR.

/* Pull up their SecProfile */

FIND SecProfile OF SecUser NO-LOCK NO-ERROR.

/* Is this SecProfile part of the allowable profiles to see this report? */

RUN CheckProfile 
(INPUT cGroupList, 
 INPUT SecProfile.Name, 
 OUTPUT lIsGroupMember).

IF NOT lIsGroupMember THEN RETURN.

/* Passed all the tests for @secure() */

ASSIGN cErrorReport = "".

/* If they are allowed, then replace @secure() with nothing to eliminate */
/* it from the report text.                                              */

ASSIGN cOutText = REPLACE(cOutText, cRptSub, "").

PROCEDURE CheckProfile:
  DEF INPUT PARAMETER cProfileList    AS CHARACTER NO-UNDO.
  DEF INPUT PARAMETER cGroup          AS CHARACTER NO-UNDO.
  DEF OUTPUT PARAMETER lResult        AS LOGICAL NO-UNDO.

  DEF VAR i      AS INTEGER NO-UNDO.
  DEF VAR l      AS INTEGER NO-UNDO.

  ASSIGN l = NUM-ENTRIES(cProfileList, "|").

  DO i = 1 TO l:

    IF ENTRY(i, cProfileList, "|") = cGroup THEN DO:
      ASSIGN lResult = YES.
      RETURN.
    END.

  END.

   ASSIGN lResult = NO.

END. /* PROCEDURE CheckProfile */
