

/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/Denkh/src/rptgen/RCS/TrkSubTotal.p,v 3.0 2003/06/25 07:12:41 sauge Exp $" NO-UNDO. 

/* Find @trksubtotal() macros, update the appropriate record */
/* Bail out.                                                 */

DEF INPUT PARAMETER cS AS CHARACTER NO-UNDO.
DEF OUTPUT PARAMETER cT AS CHARACTER NO-UNDO.

DEF SHARED TEMP-TABLE SubTotals
  FIELD Name AS CHARACTER
  FIELD Sum  AS DECIMAL
  FIELD String AS CHARACTER 
  INDEX Key1 IS PRIMARY Name.

/* Go through the input looking for @SubTotal()'s, take out the program, take out the input  */
/* for the program, run the program, replace the whole thing with the program's output. */

/* Embeds happen in the order they are discovered, top to down, left to right.          */

DEF VAR cB         AS CHARACTER NO-UNDO.
DEF VAR cSub       AS CHARACTER NO-UNDO.
DEF VAR cSubTotal       AS CHARACTER NO-UNDO.
DEF VAR cSubTotalArg    AS CHARACTER NO-UNDO.
DEF VAR cSubTotalOutPut AS CHARACTER NO-UNDO.
 
ASSIGN cT = cS.
  
REPEAT:
      
    /* If there is no holder, then leave */
     
   IF INDEX (cT, "@trksubtotal(") = 0 THEN LEAVE.
     
   /* We found one - chop out the arguments and go run things */
   /* It is the right one, pull out the contents between  */
   /* the ( and ) characters.  The first argument is the  */
   /* Program name to run, the second is the input to the */
   /* program name.  Note the input should always be a    */
   /* string.                                             */
     
   ASSIGN cB = SUBSTRING (cT, INDEX (cT, "@trksubtotal(") + 13).
          cB = SUBSTRING (cB, 1, INDEX(cB, ")") - 1).

   /* Subtotal name is the first argument */
 
   cSubTotal = ENTRY(1, cB).

   /* Argument to the program is the second argument */

   cSubTotalArg = ENTRY(2, cB).

   /* Find the record for this subtotal.  If not available, */
   /* then go create it and populate.                       */

   FIND SubTotals WHERE
   SubTotals.Name = cSubTotal
   NO-ERROR.

   IF NOT AVAILABLE SubTotals THEN DO:

     CREATE SubTotals.
     ASSIGN SubTotals.Name = cSubTotal.

   END.

   ASSIGN SubTotals.Sum = SubTotals.Sum + DECIMAL(cSubTotalArg).

   /* We don't want the macro to remain in the report text! */

   ASSIGN cSub = "@trksubtotal(" + cB + ")".
   ASSIGN cT = REPLACE (cT, cSub, "").

END. /* REPEAT: */


