/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/Denkh/src/rptgen/RCS/qrytbls.p,v 3.0 2003/06/25 07:12:41 sauge Exp $" NO-UNDO. 

DEF INPUT PARAMETER   cQuery  AS CHARACTER NO-UNDO.
DEF OUTPUT PARAMETER  cTableList AS CHARACTER NO-UNDO.

DEF VAR i AS INTEGER NO-UNDO.
DEF VAR j AS INTEGER NO-UNDO.
DEF VAR cNominee AS CHARACTER NO-UNDO.

/* You MUST prepopulate RptBuffer with the names of physical */
/* tables before using the system, else it will not be able  */
/* to determine the table names in the query.                */
/* Use the command poprptbuffer.ksh for more information.    */
/* If your query is going to use buffers for 2 or more rec-  */
/* ords in a given table, be sure it have the buffer named   */
/* via the ListRptBuffer.html, InputRptBuffer.html, and      */
/* EditRptBuffer.html pages.  (Or programmatically!)         */

/* Flip through each _File looking if it exists for the given */
/* string pulled from the cQuery.  If it does - then check if */
/* we have already got it and if not, then put it into the    */
/* list.                                                      */

/* Blow away , : > < and = signs cuz they mess things up!     */

RUN StripChar.p (INPUT cQuery, INPUT ",:<>=", OUTPUT cQuery).

ASSIGN cQuery = TRIM(cQuery).

NOMINEE:
DO i = 1 TO NUM-ENTRIES(cQuery, " "):

  ASSIGN cNominee = ENTRY(i, cQuery, " ").

  DO j = 1 TO NUM-ENTRIES(cTableList):
    
    IF ENTRY(j, cTableList) = cNominee THEN NEXT NOMINEE.
  
  END.

  IF NOT CAN-FIND(RptBuffer WHERE RptBuffer.BufName = cNominee) THEN NEXT.

  ASSIGN cTableList = cTableList + "," + cNominee.

END. /* DO i = 1 TO NUM-ENTRIES(cQuery) */

ASSIGN cTableList = SUBSTRING(cTableList, 2).

